# net devices — NCM API

The network interfaces currently enabled on a Cradlepoint device: modems, Ethernet WANs and the rest. Read-only, a single list call. Nearly every cellular metric endpoint keys off a net device ID from here, which makes this the join between a router and its links.

Base URL: https://www.cradlepointecm.com/api/v2

### GET /net_devices/

Get information about net_devices

Use the GET method on this endpoint to retrieve net_devices records. Use the available filtering fields to narrow or broaden your search.

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| X-ECM-API-ID | header | string | yes | <strong>ECM API app Id</strong> |
| X-ECM-API-KEY | header | string | yes | <strong>ECM API app key</strong> |
| X-CP-API-ID | header | string | yes | <strong>Cradlepoint API app Id</strong> |
| X-CP-API-KEY | header | string | yes | <strong>Cradlepoint API access key</strong> |
| account | query | in: int<br />out: url | no | Account that owns the net_devices record |
| account__in | query | in: int<br />out: url | no | Filter for account contains - a comma-separated list of account IDs |
| connection_state | query | string (connected | connecting | disconnecting | disconnected | error | ready | configuring | unplugged) | no | Connection state of a net device |
| connection_state__in | query | string | no | Filter for connection_state contains - a comma-separated list of connection states |
| id | query | integer | no | ID of the net_devices record |
| id__in | query | integer | no | Filter for ID contains - a comma-separated list of net_devices IDs. |
| id__gt | query | integer | no | Filter results to items with ID greater than specified value (cursor pagination) |
| id__gte | query | integer | no | Filter results to items with ID greater than or equal to specified value |
| id__lt | query | integer | no | Filter results to items with ID less than specified value |
| id__lte | query | integer | no | Filter results to items with ID less than or equal to specified value |
| is_asset | query | boolean | no | True for modem network devices |
| ipv4_address | query | string | no | Device's IPv4 address |
| ipv4_address__in | query | string | no | Filter for ipv4_address contains - a comma-separated list of ipv4 addresses |
| mode | query | string (wan | lan) | no | Network device's mode, either WAN or LAN |
| mode__in | query | string | no | Filter for mode contains - a comma-separated list of modes |
| router | query | in: int<br />out: url | no | Cradlepoint device the network device is currently connected |
| router__in | query | in: int<br />out: url | no | Filter for router contains - a comma-separated list of router IDs |
| expand | query | string (account | router) | no | Specifies that the returned value for the passed in attribute be expanded in the response body |
| limit | query | integer | no | Restricts the number of records returned in a recordset to this value. Max value is 500. |
| offset | query | integer | no | Specifies where (an index) in a recordset to begin returning records. |

**Example request**

```bash
curl "https://www.cradlepointecm.com/api/v2/net_devices/" \
  -H "X-CP-API-ID: <cp-api-id>" \
  -H "X-CP-API-KEY: <cp-api-key>" \
  -H "X-ECM-API-ID: <ecm-api-id>" \
  -H "X-ECM-API-KEY: <ecm-api-key>"
```

**Response 200** — Example response.

```json
{
  "data": [
    {
      "account": "https://www.cradlepointecm.com/api/v2/accounts/<account number>/",
      "bsid": null,
      "carrier": "Unknown Service",
      "carrier_id": null,
      "channel": null,
      "connection_state": "unplugged",
      "dns0": null,
      "dns1": null,
      "esn": null,
      "gateway": null,
      "gsn": "353547063430048",
      "homecarrid": null,
      "hostname": "JGE-IBR900-f1d",
      "iccid": null,
      "id": "32081658",
      "imei": "353547063430048",
      "imsi": null,
      "ipv4_address": null,
      "ipv6_address": null,
      "is_asset": true,
      "is_gps_supported": true,
      "is_upgrade_available": false,
      "is_upgrade_supported": true,
      "ltebandwidth": null,
      "mac": null,
      "manufacturer": "Cradlepoint Inc.",
      "mdn": null,
      "meid": "35354706343004",
      "mfg_model": "MC7354-CP",
      "mfg_product": "Internal LPE (SIM1)",
      "mn_ha_spi": null,
      "mn_ha_ss": null,
      "mode": "wan",
      "model": "Internal LPE-VZ (SIM1)",
      "modem_fw": "Verizon Wireless",
      "mtu": 1428,
      "nai": null,
      "name": "mdm-c5be779",
      "netmask": null,
      "pin_status": "NOSIM",
      "port": "int1",
      "prlv": null,
      "profile": null,
      "resource_url": "https://www.cradlepointecm.com/api/v2/net_devices/32081658/",
      "rfband": null,
      "rfchannel": null,
      "roam": null,
      "router": null,
      "rxchannel": null,
      "serial": "353547063430048",
      "service_type": "Not Available",
      "ssid": null,
      "summary": "unplugged",
      "txchannel": null,
      "type": "mdm",
      "uid": "c5be779",
      "updated_at": "2018-12-12T16:41:31.117640+00:00",
      "uptime": null,
      "ver_pkg": "05.05.58.01_VZW,005.030_000",
      "version": "SWI9X15C_05.05.58.01 r27044 carmd-fwbuild1 2015/03/05 00:02:40",
      "wimax_realm": "sprintpcs.com"
    }
  ],
  "meta": {
    "limit": 20,
    "next": null,
    "offset": 0,
    "previous": null
  }
}
```
